using System;
using System.Collections.Generic;
using System.Text;
using KeggAPI.WebService.Kegg;
using VVVV.PluginInterfaces.V1;

namespace VVVV.Nodes
{
    public class bGetNode : BaseSoapClientPlugin<KEGG>,IPlugin
    {
        private IStringIn FPinInID;
        private IStringOut FPinOutDetails;

        #region Plugin Information
        public static IPluginInfo PluginInfo
        {
            get
            {
                IPluginInfo Info = new PluginInfo();
                Info.Name = "BGet";
                Info.Category = "Kegg";
                Info.Version = "";
                Info.Help = "Get details from an item in kegg database from it's ID";
                Info.Bugs = "";
                Info.Credits = "";
                Info.Warnings = "";
                Info.Author = "vux";
                Info.Tags = "";

                //leave below as is
                System.Diagnostics.StackTrace st = new System.Diagnostics.StackTrace(true);
                System.Diagnostics.StackFrame sf = st.GetFrame(0);
                System.Reflection.MethodBase method = sf.GetMethod();
                Info.Namespace = method.DeclaringType.Namespace;
                Info.Class = method.DeclaringType.Name;
                return Info;
            }
        }
        #endregion

        protected override void OnConfigurate(IPluginConfig Input)
        {
            
        }

        protected override void OnEvaluate(int SpreadMax, bool settingschanged)
        {
            if (settingschanged || this.FPinInID.PinIsChanged)
            {
                List<string> results = new List<string>();
                this.FPinOutDetails.SliceCount = this.FPinInID.SliceCount;
                for (int i = 0 ; i < this.FPinInID.SliceCount; i++) 
                {
                    string id;
                    this.FPinInID.GetString(i, out id);
                    if (id.Length > 0)
                    {
                        string result = this.FServiceProxy.bget(id);
                        this.FPinOutDetails.SetString(i, result);
                    }
                    else
                    {
                        this.FPinOutDetails.SetString(i, "");
                    }
                }
            }
        }

        protected override void OnPluginHostSet()
        {
            
            this.FHost.CreateStringInput("ID", TSliceMode.Dynamic, TPinVisibility.True, out this.FPinInID);
            this.FPinInID.SetSubType("", false);

            this.FHost.CreateStringOutput("Output", TSliceMode.Dynamic, TPinVisibility.True,out this.FPinOutDetails);
            this.FPinOutDetails.SetSubType("", false);
        
        }

        protected override string DefaultUrl
        {
            get { return "http://soap.genome.jp/keggapi/request_v6.2.cgi"; }
        }
    }
}
